// Code generated by github.com/atombender/go-jsonschema, DO NOT EDIT.

package frames

import "fmt"
import "encoding/json"

// Serialized data received by GCS Transceiver and propagated to ZMQ network
type RxFrameSchemaJson struct {
	// Spacecraft GPS altitude in meters.
	Altitude *float64 `json:"altitude,omitempty" yaml:"altitude,omitempty" mapstructure:"altitude,omitempty"`

	// Spacecraft GPS latitude in degrees.
	Latitude *float64 `json:"latitude,omitempty" yaml:"latitude,omitempty" mapstructure:"latitude,omitempty"`

	// Spacecraft GPS longitude in degrees.
	Longitude *float64 `json:"longitude,omitempty" yaml:"longitude,omitempty" mapstructure:"longitude,omitempty"`

	// Spacecraft identifier. Specific for every mission.
	SpacecraftId int `json:"spacecraft_id" yaml:"spacecraft_id" mapstructure:"spacecraft_id"`

	// UNIX timestamp of radio frame reception.
	Timestamp int `json:"timestamp" yaml:"timestamp" mapstructure:"timestamp"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *RxFrameSchemaJson) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["spacecraft_id"]; !ok || v == nil {
		return fmt.Errorf("field spacecraft_id in RxFrameSchemaJson: required")
	}
	if v, ok := raw["timestamp"]; !ok || v == nil {
		return fmt.Errorf("field timestamp in RxFrameSchemaJson: required")
	}
	type Plain RxFrameSchemaJson
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = RxFrameSchemaJson(plain)
	return nil
}
